# xDevs.com Python 10V test for 3458A
# http://xdevs.com/guide/ni_gpib_rpi/
import os.path
import sys
import Gpib
import time
import ftplib
import numbers
import signal
import time
import math
import Adafruit_GPIO.SPI as SPI
import Adafruit_MAX31855.MAX31855 as MAX31855

# Define a function to convert celsius to fahrenheit.
def c_to_f(c):
        return c * 9.0 / 5.0 + 32.0

# Raspberry Pi hardware SPI configuration.
SPI_PORT   = 0
SPI_DEVICE = 0
sensor = MAX31855.MAX31855(spi=SPI.SpiDev(SPI_PORT, SPI_DEVICE))

root_dir = '/repo/cryoltz/'
fileName4 = root_dir + 'cryoltz_34970a_nplc100_tin.csv'

cnt = 0
tread = 20
reflevel = 
refhp = 5.0
lntemp = 0.0
tec_start = 24
tec_stop = 50
tec_step = 0.1
tec_time = 50

tec_rtd = 0.3
temp = 18.0
res_rtd = 0.3
exttemp = 25.0
rh = 50.0
pascals = 100000.00
hectopascals = 1000.00
tset = 18.0

class Timeout():
  """Timeout class using ALARM signal"""
  class Timeout(Exception): pass

  def __init__(self, sec):
    self.sec = sec

  def __enter__(self):
    signal.signal(signal.SIGALRM, self.raise_timeout)
    signal.alarm(self.sec)

  def __exit__(self, *args):
    signal.alarm(0) # disable alarm

  def raise_timeout(self, *args):
    raise Timeout.Timeout()

class scpi_meter():
    temp = 38.5
    data = ""
    ppm = 0.0
    status_flag = 1
    temp_status_flag = 1
    global exttemp
    global rh
    global hectopascals
    global res_rtd

    def __init__(self,gpib,reflevel,name):
        self.gpib = gpib
        self.inst = Gpib.Gpib(0,self.gpib, timeout=90) # SCPI GPIB Address = self.gpib
        self.reflevel = reflevel
        self.name = name
        self.init_inst()

    def init_inst(self):
        # Setup SCPI DMM
        self.inst.clear()
        self.inst.write("*RST")
        self.inst.write("*CLR")
        self.inst.write("CONF:VOLT:DC 10,(@113)\n")
        self.inst.write(":SYST:LSYN:STAT ON")
        #self.inst.write(":sens:temp:tran rtd")      #select thermistor
        #self.inst.write(":sens:temp:rtd:type user") #10 kOhm thermistor
        #self.inst.write(":sens:temp:rtd:alph 0.00375") #10 kOhm thermistor
        #self.inst.write(":sens:temp:rtd:beta 0.160") #10 kOhm thermistor
        #self.inst.write(":sens:temp:rtd:delt 1.605") #10 kOhm thermistor
        #self.inst.write(":sens:temp:rtd:rzer 1000") #10 kOhm thermistor
        #self.inst.write(":SENS:FUNC 'TEMP'")
        self.inst.write("ROUT:MON:CHAN (@112)")
        self.inst.write("ROUT:MON:STAT ON\n")
        self.inst.write("ROUT:MON:DATA?\n")
        self.inst.write(":FUNC:VOLT:DC:SENS:VOLT:DC:RANG 20") 
        #self.inst.write(":SENS:TEMP:DIG 9")
        #self.inst.write(":SENS:TEMP:NPLC 10")
        self.inst.write("SENSe:VOLTage:DC:RANGe (@113) ")
        self.inst.write("READ?")

    def read_data(self,cmd):
        data_float = 0.0
        data_str = ""
        self.inst.write(cmd)
        try:
            with Timeout(90):
                data_str = self.inst.read()
        except Timeout.Timeout:
            print ("Timeout exception from dmm %s on read_data() inst.read()\n" % self.name)
            return (0,float(0))
        #print ("Reading from dmm %s = %s" % (self.name,data_str))
        try:
            data_float = float(data_str)
        except ValueError:
            print("Exception thrown by dmm %s on read_data() - ValueError = %s\n" % (self.name,data_str))
            return (0,float(0)) # Exception on float conversion, 0 = error
        return (1,data_float) # Good read, 1 = converted to float w/o exception

    def get_data(self):
        self.status_flag,data = self.read_data("READ?")
        if (self.status_flag):
            self.data = data
            self.ppm = ((float(self.data) / self.reflevel)-1)*1E6
            self.res_rtd = data
        return self.data

    def get_data_status(self):
        return self.status_flag

    def write_datae(self, fileHandle):
        fileHandle.write("\r\n");

    def write_data(self, fileHandle):
        global lntemp
        #tempc = (float(res_rtd) - 0.75) / 0.01
        #fileHandle.write(";%2.3f;\r\n" % tempc);
        #fileHandle.write(";%16.8f;" % float(self.data));
        print time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;31m[%8d]: %2.9f , dev %4.2f ppm,\033[1;39m  EXT_T:%3.2f , RH:%3.2f , Press:%4.2f hPa, LN2: {0:0.3F} C" % (cnt, float(self.data),float(self.ppm),float(exttemp),float(rh),float(hectopascals), .format(lntemp) ) )
        fileHandle.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%2.9f;%3.2f;%3.2f;%4.2f;{0:0.3F}\r\n" % (float(self.data),float(exttemp),float(rh),float(hectopascals), .format(lntemp) ) ))

    def print_ppm(self):
        #res_rtd = self.data
        #tempc = (float(res_rtd) - 0.75) / 0.01
        vdc = self.data
        self.inst.write(":DISP:WIND:TEXT:DATA \"       \"")
        #self.inst.write(":DISP:WIND2:TEXT:DATA \"  \"")

# Read Temperature, Humidity, and Barometric Pressure from BME280
def get_THP():
    global exttemp
    global rh
    global pascals
    global hectopascals
    exttemp = 24 #sensor.read_temperature()
    rh = 40 #sensor.read_humidity()
    pascals = 1000000# sensor.read_pressure()
    hectopascals = pascals / 100
    time.sleep(0.1)

# Check if file exists, if not create it and add header
def create_local_file(fileName):
    if (os.path.isfile(fileName) == False):
        with open(fileName, 'a') as o:
            o.write("date;dmm;;ext_temp;rh;pressure;cryotemp;\r\n")
            print ("file %s does not exist\r\n" % fileName) 
    else: 
        print ("file %s exists\r\n" % fileName)

meter = scpi_meter(5,refhp,"2002_00000") # Gpib 10

#Setup temp/humidity/pressure sensor BME280
# OSAMPLE = oversampling mode
sensor = BME280(mode=BME280_OSAMPLE_8)
get_THP() # Read Temp, RH, Pressure from sensor

# Create file for 1st 3458A and write header if needed
create_local_file(fileName4)
#meter2510.cfg_temp()

temp = 24.0

# Loop printing measurements every second.
    
    #internal = sensor.readInternalC()
    
    #print('\033[1;36m    Internal Temperature: {0:0.3F}*C / {1:0.3F}*F\033[0;39m'.format(internal, c_to_f(internal)))

while cnt <= 20000000:
    cnt+=1

    with open(fileName4, 'a') as o1: # Open file handles for both files
        global lntemp
        get_THP() # Read Temp, RH, Press from sensor
        tread = tread - 1
        if (tread == 0):
            tread = 50
        lntemp = sensor.readLinearizedTempC()
        if (math.isnan(lntemp) == False) and (temp != 0.000):
        #print temp
            print('\033[1;33mThermocouple K Temperature: {0:0.3F} '.format(lntemp))

        meter.get_data()
        if (meter.get_data_status()):
                meter.write_data(o1)
            meter.write_data(o1)

        o1.close()
